<template>
  <form class="my-8 space-y-4" @submit.prevent="onEnter">
    <h2 v-if="title !== null">
      {{ title }}
    </h2>
    <slot :values="values" :handleSubmit="handleSubmit" />
  </form>
</template>

<script>
export default {
  name: "Vuemik",
  props: {
    initialValues: {
      default: {}
    },
    title: {
      type: String,
      default: null
    },
    onSubmit: {
      type: Function
    },
    submitWithEnter: {
      type: Boolean,
      default: true
    },
    violations: {
      default: () => ({})
    }
  },
  data: function() {
    return {
      values: this.recursiveCloneObj(this.initialValues)
    };
  },
  provide() {
    const provider = { values: {}, violations: {} };
    for (const key in this.values) {
      Object.defineProperty(provider.values, key, {
        enumerable: true,
        get: () => this.values[key],
        set: value => (this.values[key] = value)
      });
    }
    for (const key in this.violations) {
      Object.defineProperty(provider.violations, key, {
        enumerable: true,
        get: () => this.violations[key]
      });
    }
    return provider;
  },
  methods: {
    onEnter() {
      if (this.submitWithEnter)
        this.handleSubmit()
    },
    handleSubmit() {
      this.onSubmit(this.values);
    },
    recursiveCloneObj(obj) {
      if (obj === null)
        return obj
      if (typeof(obj) === "object") {
        if (obj instanceof Array) {
          return [...obj.map(elem => this.recursiveCloneObj(elem))]
        }
        return {
          ...Object.entries(obj).reduce((acc,[key,value]) => ({
            ...acc,
            [key]: this.recursiveCloneObj(value)
          }), {})
        }
      }
      return obj
    }
  }
};
</script>

<style scoped></style>
